;===============================================================================================
; mehrfach brechen einer linie
; starten mit gmk_brechen
; brechpunkte unbedingt in der logischen reihenfolge angeben da sonst falsche linien entstehen
; getestet auf AutoCad 2002
; 030526 gmkoenig@web.de
;===============================================================================================

(DEFUN C:gmk_brechen (/
                       wahl
                       element
                       anfp
                       endp
                       nullpunkt
                       riwi
                       lay
                       t_par
                       brechpunkt)

;=======================================================================================================================================

(DEFUN gmk_t_par_2ip (anfp1 endp1 anfp2 endp2                  ; transformation mit 2 identischen punkten
                      / r1a h1a                                ; eine drehung, eine verschiebung, ein massstabsfaktor 
                        r2a h2a 
                        m
                        riwi1 riwi2 drehw
                        o a r0 h0
                        erg )
(SETQ r1a (CAR anfp1)                                      ; Rechts und Hochwert der identischen Punkte
      h1a (CADR anfp1)                                     ; Transformation von System 1 nach System 2
      r2a (CAR anfp2)
      h2a (CADR anfp2)
      m (/ (DISTANCE anfp2 endp2) (DISTANCE anfp1 endp1))  ; Mastabsfaktor
      riwi1 (- (/ pi 2.0) (ANGLE anfp1 endp1))             ; Riwi System1 im Bogenmass
      riwi2 (- (/ pi 2.0) (ANGLE anfp2 endp2))             ; Riwi System2 im Bogenmass
      drehw (- riwi2 riwi1)                                ; Drehwinkel im Bogenmass
      o (* (SIN drehw) m)                                  ; Transformationsparameter
      a (* (COS drehw) m)
      r0 (- r2a (* o h1a) (* a r1a))
      h0 (+ (- h2a (* a h1a)) (* o r1a))

)
(LIST o a r0 h0 m drehw)                                   ; Ergebnis: Transformationsparameter
)

;=======================================================================================================================================

(DEFUN gmk_t_2ip (transfpar             ; =liste mit o a r0 h0 mastab drehwinkel
                  kleinpunkt            ; =liste rechtswert hochwert
                  / o a r0 h0 
                    rechtswert hochwert)
(SETQ o (nth 0 transfpar)
      a (nth 1 transfpar)
      r0 (nth 2 transfpar)
      h0 (nth 3 transfpar) 
      rechtswert (nth 0 kleinpunkt)
      hochwert (nth 1 kleinpunkt) 
)
(list (+ r0 (* o hochwert) (* a rechtswert)) (- (+ h0 (* a hochwert)) (* o rechtswert)))
)

;=======================================================================================================================================


(COMMAND "_UCS" "w")
(SETQ wahl (ENTSEL "Linie whlen: ")
      element (ENTGET (CAR wahl))              
      anfp (CDR(ASSOC 10 element))
      nullpunkt anfp
      endp (CDR(ASSOC 11 element))
      riwi (ANGLE anfp endp)
      lay (CDR(ASSOC 8 element))
      tpar (gmk_t_par_2ip anfp endp (list 0 0) (list 0 (DISTANCE anfp endp)))
) 
(SETVAR "clayer" lay)                                      ; layer der linie aktuell setzen 
(SETQ brechpunkt (GETPOINT "\n Brechpunkt: "))             ; kleinpunkt bis abbruch (=nil)
(WHILE brechpunkt                                          ; kleinpunkt transformieren
     (SETQ endp (POLAR nullpunkt riwi (CADR(gmk_t_2ip tpar brechpunkt))))
     (COMMAND "_LINE"  anfp endp) (COMMAND "") 
     (SETQ anfp endp)
     (SETQ brechpunkt (GETPOINT "\n Brechpunkt: "))        ; naechster kleinpunkt bis abbruch (=nil) 
) ; ende while
(ENTDEL (CAR wahl))
)


